from helper_code import *
import numpy as np, os, joblib
import math


def process_data(header, recording, leads):
    # Re Order leads
    available_leads = get_leads(header)
    indices = list()
    for lead in leads:
        i = available_leads.index(lead)
        indices.append(i)
    recording = recording[indices, :]

    adc_gains = get_adc_gains(header, leads)
    baselines = get_baselines(header, leads)
    num_leads = len(leads)
    for i in range(num_leads):
        recording[i, :] = (recording[i, :] - baselines[i]) / adc_gains[i]

    # calculating the amount of subparts and looping trough their indices
    new_recordings = np.zeros((len(leads), 5000))
    for i, lead in enumerate(recording):
        padding = np.array([0] * max(5000 - len(lead), 0))

        lead_recording = lead[0: min(len(lead), 5000)]
        q = np.concatenate((lead_recording, padding))
        new_recordings[i] = q

    return new_recordings.T


def labels_to_numberline(labels, unique_labels):
    label_am = len(unique_labels)
    _labels = np.zeros((label_am))
    for i in range(len(labels)):
        for j in range(len(unique_labels)):
            if labels[i] == unique_labels[j]:
                _labels[j] = 1

    return _labels